DOM::TreeWalker Class Reference

`#include <dom2_traversal.h>`

## Public Member Functions

| TreeWalker (const TreeWalker &other)
TreeWalker & | operator= (const TreeWalker &other)
Node | root ()
unsigned long | whatToShow ()
NodeFilter | filter ()
bool | expandEntityReferences ()
Node | currentNode ()
void | setCurrentNode (const Node &_currentNode)
Node | parentNode ()
Node | firstChild ()
Node | lastChild ()
Node | previousSibling ()
Node | nextSibling ()
Node | previousNode ()
Node | nextNode ()
TreeWalkerImpl * | handle () const
bool | isNull () const

## Protected Member Functions

| TreeWalker (TreeWalkerImpl *i)

## Protected Attributes

TreeWalkerImpl * | impl

## Friends

class | Document
class | TreeWalkerImpl

## Detailed Description

`TreeWalker` objects are used to navigate a document tree or subtree using the view of the document defined by its `whatToShow` flags and any filters that are defined for the `TreeWalker` .

Any function which performs navigation using a `TreeWalker` will automatically support any view defined by a `TreeWalker` .

Omitting nodes from the logical view of a subtree can result in a structure that is substantially different from the same subtree in the complete, unfiltered document. Nodes that are siblings in the TreeWalker view may be children of different, widely separated nodes in the original view. For instance, consider a Filter that skips all nodes except for Text nodes and the root node of a document. In the logical view that results, all text nodes will be siblings and appear as direct children of the root node, no matter how deeply nested the structure of the original document.

Definition at line 339 of file dom2_traversal.h.

## Member Function Documentation

Node TreeWalker::currentNode | ( |  | ) |

The node at which the TreeWalker is currently positioned.

Alterations to the DOM tree may cause the current node to no longer be accepted by the TreeWalker's associated filter. currentNode may also be explicitly set to any node, whether or not it is within the subtree specified by the root node or would be accepted by the filter and whatToShow flags. Further traversal occurs relative to currentNode even if it is not part of the current view, by applying the filters in the requested direction; if no traversal is possible, currentNode is not changed.

Exceptions

  DOMException | NOT_SUPPORTED_ERR: Raised if an attempt is made to set currentNode to null.

Definition at line 283 of file dom2_traversal.cpp.

bool TreeWalker::expandEntityReferences | ( |  | ) |

The value of this flag determines whether the children of entity reference nodes are visible to the TreeWalker.

If false, they and their descendents will be rejected. Note that this rejection takes precedence over whatToShow and the filter, if any.

To produce a view of the document that has entity references expanded and does not expose the entity reference node itself, use the whatToShow flags to hide the entity reference node and set expandEntityReferences to true when creating the TreeWalker. To produce a view of the document that has entity reference nodes but no entity expansion, use the whatToShow flags to show the entity reference node and set expandEntityReferences to false.

Definition at line 277 of file dom2_traversal.cpp.

NodeFilter TreeWalker::filter | ( |  | ) |

The filter used to screen nodes.

Definition at line 271 of file dom2_traversal.cpp.

Node TreeWalker::firstChild | ( |  | ) |

Moves the `TreeWalker` to the first child of the current node, and returns the new node.

If the current node has no children, returns `null` , and retains the current node.

Returns
  The new node, or `null` if the current node has no children.

Exceptions

  Exceptions | from user code Any exceptions raised by a user-written Filter will propagate through.

Definition at line 300 of file dom2_traversal.cpp.

Node TreeWalker::lastChild | ( |  | ) |

Moves the `TreeWalker` to the last child of the current node, and returns the new node.

If the current node has no children, returns `null` , and retains the current node.

Returns
  The new node, or `null` if the current node has no children.

Exceptions

  Exceptions | from user code Any exceptions raised by a user-written Filter will propagate through.

Definition at line 306 of file dom2_traversal.cpp.

Node TreeWalker::nextNode | ( |  | ) |

Moves the `TreeWalker` to the next node in document order relative to the current node, and returns the new node.

If the current node has no next node, returns `null` , and retains the current node.

Returns
  The new node, or `null` if the current node has no next node.

Exceptions

  Exceptions | from user code Any exceptions raised by a user-written Filter will propagate through.

Definition at line 330 of file dom2_traversal.cpp.

Node TreeWalker::nextSibling | ( |  | ) |

Moves the `TreeWalker` to the next sibling of the current node, and returns the new node.

If the current node has no next sibling, returns `null` , and retains the current node.

Returns
  The new node, or `null` if the current node has no next sibling.

Exceptions

  Exceptions | from user code Any exceptions raised by a user-written Filter will propagate through.

Definition at line 318 of file dom2_traversal.cpp.

Node TreeWalker::parentNode | ( |  | ) |

Moves to and returns the parent node of the current node.

If there is no parent node, or if the current node is the root node from which this TreeWalker was created, retains the current position and returns null.

Returns
  The new parent node, or null if the current node has no parent in the TreeWalker's logical view.

Exceptions

  Exceptions | from user code Any exceptions raised by a user-written Filter will propagate through.

Definition at line 294 of file dom2_traversal.cpp.

Node TreeWalker::previousNode | ( |  | ) |

Moves the `TreeWalker` to the previous node in document order relative to the current node, and returns the new node.

If the current node has no previous node, returns `null` , and retains the current node.

Returns
  The new node, or `null` if the current node has no previous node.

Exceptions

  Exceptions | from user code Any exceptions raised by a user-written Filter will propagate through.

Definition at line 324 of file dom2_traversal.cpp.

Node TreeWalker::previousSibling | ( |  | ) |

Moves the `TreeWalker` to the previous sibling of the current node, and returns the new node.

If the current node has no previous sibling, returns `null` , and retains the current node.

Returns
  The new node, or `null` if the current node has no previous sibling.

Exceptions

  Exceptions | from user code Any exceptions raised by a user-written Filter will propagate through.

Definition at line 312 of file dom2_traversal.cpp.

Node TreeWalker::root | ( |  | ) |

The root node of the TreeWalker, as specified when it was created.

Definition at line 259 of file dom2_traversal.cpp.

void TreeWalker::setCurrentNode | ( | const Node & | _currentNode | ) |

see currentNode

Definition at line 289 of file dom2_traversal.cpp.

unsigned long TreeWalker::whatToShow | ( |  | ) |

This attribute determines which node types are presented via the TreeWalker.

The available set of constants is defined in the NodeFilter interface. Nodes not accepted by whatToShow will be skipped, but their children may still be considered. Note that this skip takes precedence over the filter, if any.

Definition at line 265 of file dom2_traversal.cpp.

The documentation for this class was generated from the following files:

- dom2_traversal.h
- dom2_traversal.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys